<?php

# MEDAL OF HONOR AND QUAKE ENGINE RCON CLASS
# BY WILLIAM RUCKMAN (HTTP://RUCKMAN.NET)
    
    class mohaa_rcon
    {
    
    function rcon ($IP, $PORT, $PASSWORD, $COMMAND) {
    
    if (!validateIpAddress($IP)) {
    $data = "IP Address malformed!";
    return $data;
    }
    
    if ($PORT < 1 || $PORT > 65535 || $PORT == "") {
    $data = "Port range must be between 1-65535!";
    return $data;
    }
    
    $data = '';
    $fp = fsockopen('udp://'.$IP, $PORT, $errno, $errstr, 2);
    socket_set_timeout($fp,2);
    
    if (!$fp){
    $data = "Unable to Connect! Socket Error!";
    return $data;
    } else {
    $query = "\xFF\xFF\xFF\xFF\x02 rcon \"" . $PASSWORD . "\" " . $COMMAND;
    fwrite($fp,$query);
    }
    $data = '';
    while ($d = fread ($fp, 10000)) {
        $data .= $d;
        }
        fclose ($fp);        
        if ($data == "") {
        $data = "Connection failed, No responds from server, or changing maps.";
        return $data;
        }
        $data = preg_replace ("/.....print\n/", "", $data);
        if ($data == "") {
        $data = "Command sent successfully but returned no output. Possible bad command.";
        }
        
        return $data;
        }
                        
    }

function validateIpAddress($IP)
{
if(preg_match("/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/",$IP))
{
$parts=explode(".",$IP);
foreach($parts as $ip_parts)
{
if(intval($ip_parts)>255 || intval($ip_parts)<0)
return false;
}
return true;
}
else
return false;
}

?>
